## mapcode 2.5.1

=== CMakeLists.txt ===
# Copyright (C) 2014-2016 Stichting Mapcode Foundation (http://www.mapcode.com)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.3)
project(mapcode_cpp)

# The debug configuration adds the "address sanitizer" to check for out of bounds behavior and such.
# You may wish to set the following environment variables during runtime as well:
#
# export ASAN_OPTIONS=debug=true:strict_string_checks=1:detect_stack_use_after_return=true:detect_invalid_pointer_pairs=99999:
#   detect_container_overflow=true:detect_odr_violation=2:check_initialization_order=true
#
# Compiler directives (for internal use only):
#
# NO_POSIX_THREADS      - No multi-threaded unit testing - only effective for unit test.
# NO_FAST_ENCODE        - Drop fast encoding support - only for internal use.

set(MAPCODE_OPTIONS "")
set(MAPCODE_WARNING_OPTIONS "-Wall -Werror")
set(MAPCODE_SANITIZER_COMPILER_OPTIONS "-fsanitize=address -fno-common -fno-optimize-sibling-calls -fno-omit-frame-pointer")
set(MAPCODE_SANITIZER_LINKER_OPTIONS "-fsanitize=address")

set(CMAKE_C_FLAGS_DEBUG "${MAPCODE_OPTIONS} ${MAPCODE_WARNING_OPTIONS} ${MAPCODE_SANITIZER_COMPILER_OPTIONS} -O0 -g -DDEBUG")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "${MAPCODE_OPTIONS} ${MAPCODE_WARNING_OPTIONS} ${MAPCODE_SANITIZER_COMPILER_OPTIONS} -O2 -g -DNDEBUG")
set(CMAKE_C_FLAGS_RELEASE "${MAPCODE_OPTIONS} ${MAPCODE_WARNING_OPTIONS} -O3 -DNDEBUG")

set(CMAKE_CXX_FLAGS_DEBUG "${MAPCODE_OPTIONS} ${MAPCODE_WARNING_OPTIONS} ${MAPCODE_SANITIZER_COMPILER_OPTIONS} -O0 -g -DDEBUG -std=c++11")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${MAPCODE_OPTIONS} ${MAPCODE_WARNING_OPTIONS} ${MAPCODE_SANITIZER_COMPILER_OPTIONS} -O2 -g -DNDEBUG -std=c++11")
set(CMAKE_CXX_FLAGS_RELEASE "${MAPCODE_OPTIONS} ${MAPCODE_WARNING_OPTIONS} -O3 -DNDEBUG -std=c++11")

set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${MAPCODE_SANITIZER_LINKER_OPTIONS}")
set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${MAPCODE_SANITIZER_LINKER_OPTIONS}")
set(CMAKE_EXE_LINKER_FLAGS_RELEASE "")

set(SOURCE_FILES_MAPCODELIB
        mapcodelib/internal_data.h
        mapcodelib/internal_alphabet_recognizer.h
        mapcodelib/internal_iso3166_data.h
        mapcodelib/internal_territory_alphabets.h
        mapcodelib/internal_territory_names_english.h
        mapcodelib/internal_territory_names_local.h
        mapcodelib/internal_territory_search.h
        mapcodelib/mapcode_alphabets.h
        mapcodelib/mapcode_legacy.c
        mapcodelib/mapcode_legacy.h
        mapcodelib/mapcode_territories.h
        mapcodelib/mapcoder.c
        mapcodelib/mapcoder.h)

set(SOURCE_FILES_UNITTEST
        unittest/decode_test.h
        unittest/unittest.c)

set(SOURCE_FILES_UTILITY
        utility/mapcode.cpp)

add_library(mapcodelib ${SOURCE_FILES_MAPCODELIB})
target_include_directories(mapcodelib PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(unittest ${SOURCE_FILES_UNITTEST})
target_link_libraries(unittest LINK_PUBLIC mapcodelib)

add_executable(mapcode ${SOURCE_FILES_UTILITY})
target_link_libraries(mapcode LINK_PUBLIC mapcodelib)

=== debian/changelog ===
mapcode (2.5.1-1) unstable; urgency=medium

  * Initial release (Closes: #842784)

 -- Stefan Fritsch <sf@debian.org>  Wed, 02 Nov 2016 19:24:20 +0100

=== debian/control ===
Source: mapcode
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Stefan Fritsch <sf@debian.org>
Section: misc
Priority: optional
Build-Depends: debhelper (>= 9), cmake (>= 3.3)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/mapcode.git/
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/mapcode.git
Homepage: http://www.mapcode.com/
Multi-Arch: foreign

Package: mapcode
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Convert geo coordinates to/from mapcodes
 A mapcode represents a location. Every location on Earth can be
 represented by a mapcode. Mapcodes were designed to be short, easy to
 recognise, remember and communicate. They are precise to a few meters,
 which is good enough for every-day use. Locations in densely populated
 areas often get shorter mapcodes. See http://www.mapcode.com/
 .
 This package contains a command line utility that can convert to and
 from mapcodes.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# some helpful variables - uncomment them if needed
# shamelessly stolen from http://jmtd.net/log/awk/
#DEBVERS        := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
#VERSION        := $(shell echo '$(DEBVERS)' | sed -e 's/^[0-9]*://' -e 's/-.*//')
#DEBFLAVOR      := $(shell dpkg-parsechangelog | awk '/^Distribution:/ {print $$2}')
#DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
#DEBIAN_BRANCH  := $(shell awk 'BEGIN{FS="[= ]+"} /debian-branch/ {print $$2}' debian/gbp.conf)
#GIT_TAG        := $(subst ~,_,$(VERSION))

# alternatively to manually set those variables you can
#  include /usr/share/cdbs/1/rules/buildvars.mk
# and use what is set there.  Any hint whether dh might set variables in
# a similar manner are welcome.

%:
	dh $@ --parallel -Bobj

override_dh_auto_test:
	cd unittest && ../obj/unittest

#get-orig-source:
#	. debian/get-orig-source

=== debian/watch ===
version=3

https://github.com/mapcode-foundation/mapcode-cpp/releases v(.*).tar.gz

## mapcode 2.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 # NO_FAST_ENCODE        - Drop fast encoding support - only for internal use.
 
 set(MAPCODE_OPTIONS "")
-set(MAPCODE_WARNING_OPTIONS "-Wall -Werror")
+set(MAPCODE_WARNING_OPTIONS "-Wall -Werror -Wextra")
 set(MAPCODE_SANITIZER_COMPILER_OPTIONS "-fsanitize=address -fno-common -fno-optimize-sibling-calls -fno-omit-frame-pointer")
 set(MAPCODE_SANITIZER_LINKER_OPTIONS "-fsanitize=address")
 
@@ -48,8 +48,34 @@
         mapcodelib/internal_alphabet_recognizer.h
         mapcodelib/internal_iso3166_data.h
         mapcodelib/internal_territory_alphabets.h
-        mapcodelib/internal_territory_names_english.h
+        mapcodelib/internal_territory_names_af.h
+        mapcodelib/internal_territory_names_ar.h
+        mapcodelib/internal_territory_names_be.h
+        mapcodelib/internal_territory_names_cn.h
+        mapcodelib/internal_territory_names_cs.h
+        mapcodelib/internal_territory_names_da.h
+        mapcodelib/internal_territory_names_de.h
+        mapcodelib/internal_territory_names_en.h
+        mapcodelib/internal_territory_names_es.h
+        mapcodelib/internal_territory_names_fi.h
+        mapcodelib/internal_territory_names_fr.h
+        mapcodelib/internal_territory_names_he.h
+        mapcodelib/internal_territory_names_hi.h
+        mapcodelib/internal_territory_names_hr.h
+        mapcodelib/internal_territory_names_id.h
+        mapcodelib/internal_territory_names_it.h
+        mapcodelib/internal_territory_names_ja.h
+        mapcodelib/internal_territory_names_ko.h
         mapcodelib/internal_territory_names_local.h
+        mapcodelib/internal_territory_names_nl.h
+        mapcodelib/internal_territory_names_no.h
+        mapcodelib/internal_territory_names_pl.h
+        mapcodelib/internal_territory_names_pt.h
+        mapcodelib/internal_territory_names_ru.h
+        mapcodelib/internal_territory_names_sv.h
+        mapcodelib/internal_territory_names_sw.h
+        mapcodelib/internal_territory_names_tr.h
+        mapcodelib/internal_territory_names_uk.h
         mapcodelib/internal_territory_search.h
         mapcodelib/mapcode_alphabets.h
         mapcodelib/mapcode_legacy.c
@@ -58,18 +84,30 @@
         mapcodelib/mapcoder.c
         mapcodelib/mapcoder.h)
 
-set(SOURCE_FILES_UNITTEST
-        unittest/decode_test.h
-        unittest/unittest.c)
+set(SOURCE_FILES_TEST
+        test/decode_test.h
+        test/unittest.c)
 
 set(SOURCE_FILES_UTILITY
         utility/mapcode.cpp)
 
+set(THREADS_PREFER_PTHREAD_FLAG ON)
+find_package(Threads REQUIRED)
+find_library(M_LIB m)
+
 add_library(mapcodelib ${SOURCE_FILES_MAPCODELIB})
 target_include_directories(mapcodelib PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
+target_link_libraries(mapcodelib Threads::Threads)
+target_link_libraries(mapcodelib ${M_LIB})
 
-add_executable(unittest ${SOURCE_FILES_UNITTEST})
+add_executable(unittest ${SOURCE_FILES_TEST})
 target_link_libraries(unittest LINK_PUBLIC mapcodelib)
+target_link_libraries(unittest LINK_PUBLIC Threads::Threads)
+target_link_libraries(unittest LINK_PUBLIC ${M_LIB})
 
 add_executable(mapcode ${SOURCE_FILES_UTILITY})
 target_link_libraries(mapcode LINK_PUBLIC mapcodelib)
+target_link_libraries(mapcode LINK_PUBLIC Threads::Threads)
+target_link_libraries(mapcode LINK_PUBLIC ${M_LIB})
+
+install(TARGETS mapcode DESTINATION /usr/local/bin)

=== debian/changelog ===
mapcode (2.5.2-1) unstable; urgency=medium

  * New upstream release

 -- Stefan Fritsch <sf@debian.org>  Sun, 15 Jan 2017 15:04:54 +0100

mapcode (2.5.1-2) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Fix watch file and handle common issues.
  * Restructure control file with cme.
  * Reorder fields in copyright file.
  * Drop unused get-orig-source script.

  [ Stefan Fritsch ]
  * Add -fsigned-char to fix test failures. Closes: #843084

 -- Stefan Fritsch <sf@debian.org>  Thu, 03 Nov 2016 21:13:39 +0100

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,15 @@
 Uploaders: Stefan Fritsch <sf@debian.org>
 Section: misc
 Priority: optional
-Build-Depends: debhelper (>= 9), cmake (>= 3.3)
+Build-Depends: debhelper (>= 9),
+               cmake (>= 3.3)
 Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/mapcode.git/
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/mapcode.git
 Homepage: http://www.mapcode.com/
-Multi-Arch: foreign
 
 Package: mapcode
+Multi-Arch: foreign
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,5 @@
 	dh $@ --parallel -Bobj
 
 override_dh_auto_test:
-	cd unittest && ../obj/unittest
+	cd test && ../obj/unittest
 
-#get-orig-source:
-#	. debian/get-orig-source

## mapcode 2.5.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2014-2016 Stichting Mapcode Foundation (http://www.mapcode.com)
+# Copyright (C) 2014-2017 Stichting Mapcode Foundation (http://www.mapcode.com)
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.

=== debian/changelog ===
mapcode (2.5.5-5) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.6.1, no changes.
  * Update watch file for GitHub URL changes.
  * Bump debhelper compat to 12, no changes.
  * Add Rules-Requires-Root to control file.
  * Updte lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Dec 2022 12:19:27 +0100

mapcode (2.5.5-4) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.5.0, no changes.
  * Update watch file to limit matches to archive path.
  * Remove package name from lintian overrides.
  * Update gbp.conf to use --source-only-changes by default.
  * Bump debhelper compat to 10, changes:
    - Drop --parallel option, enabled by default
  * Bump watch file version to 4.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 11 Nov 2020 19:31:48 +0100

mapcode (2.5.5-3) unstable; urgency=medium

  * Team upload.
  * Drop autopkgtest to test installability.
  * Add lintian override for testsuite-autopkgtest-missing.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 31 Jul 2018 21:12:39 +0200

mapcode (2.5.5-2) unstable; urgency=medium

  * Team upload.
  * Update Vcs-* URLs for Salsa.
  * Bump Standards-Version to 4.1.5, no changes.
  * Strip trailing whitespace from rules file.
  * Check DEB_BUILD_OPTIONS for nocheck in dh_auto_test override.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 29 Jul 2018 11:07:09 +0200

mapcode (2.5.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright-format URL to use HTTPS.
  * Update copyright years for Stichting Mapcode Foundation.
  * Restructure control file with cme.
  * Bump Standards-Version to 4.1.3, no changes.
  * Enable all hardening buildflags.
  * Add autopkgtest to test installability.
  * Add lintian override for spelling-error-in-binary false positive.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 28 Jan 2018 19:12:25 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,17 @@
 Uploaders: Stefan Fritsch <sf@debian.org>
 Section: misc
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 12),
                cmake (>= 3.3)
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/mapcode.git/
-Vcs-Git: https://anonscm.debian.org/git/pkg-grass/mapcode.git
+Standards-Version: 4.6.1
+Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapcode/
+Vcs-Git: https://salsa.debian.org/debian-gis-team/mapcode.git
 Homepage: http://www.mapcode.com/
+Rules-Requires-Root: no
 
 Package: mapcode
+Architecture: any
 Multi-Arch: foreign
-Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: Convert geo coordinates to/from mapcodes

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/\-/\./g,\
filenamemangle=s/(?:.*?)?(?:rel|v|mapcode)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/mapcode-cpp-$1.$2/ \
https://github.com/mapcode-foundation/mapcode-cpp/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|mapcode-cpp)?[\-\_]?(\d[\d\-\.]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## mapcode 2.5.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2014-2017 Stichting Mapcode Foundation (http://www.mapcode.com)
+# Copyright (C) 2014-2025 Stichting Mapcode Foundation (http://www.mapcode.com)
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -12,7 +12,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-cmake_minimum_required(VERSION 3.3)
+cmake_minimum_required(VERSION 3.5)
 project(mapcode_cpp)
 
 # The debug configuration adds the "address sanitizer" to check for out of bounds behavior and such.
@@ -27,7 +27,7 @@
 # NO_FAST_ENCODE        - Drop fast encoding support - only for internal use.
 
 set(MAPCODE_OPTIONS "")
-set(MAPCODE_WARNING_OPTIONS "-Wall -Werror -Wextra")
+set(MAPCODE_WARNING_OPTIONS "-Wall -Werror -Wextra -Wno-pointer-to-int-cast -Wno-deprecated-declarations -Wno-unused-but-set-variable")
 set(MAPCODE_SANITIZER_COMPILER_OPTIONS "-fsanitize=address -fno-common -fno-optimize-sibling-calls -fno-omit-frame-pointer")
 set(MAPCODE_SANITIZER_LINKER_OPTIONS "-fsanitize=address")

=== debian/changelog ===
mapcode (2.5.6-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file.
  * Drop cmake-4.patch, included upstream. Refresh remaining patches.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 11 Sep 2025 15:25:07 +0200

mapcode (2.5.5-7) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.7.2, no changes.
  * Add upstream patch to fix FTBFS with CMake 4.x.
    (closes: #1113266)

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 01 Sep 2025 07:37:36 +0200

mapcode (2.5.5-6) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.7.0, no changes.
  * Bump debhelper compat to 13.
  * Enable Salsa CI.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 06 Mar 2025 19:16:51 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Uploaders: Stefan Fritsch <sf@debian.org>
 Section: misc
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake (>= 3.3)
-Standards-Version: 4.6.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapcode/
 Vcs-Git: https://salsa.debian.org/debian-gis-team/mapcode.git
 Homepage: http://www.mapcode.com/

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #!/usr/bin/make -f
 
 # DH_VERBOSE := 1
+
+# Enable hardening build flags
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 # some helpful variables - uncomment them if needed
 # shamelessly stolen from http://jmtd.net/log/awk/
@@ -17,8 +20,9 @@
 # a similar manner are welcome.
 
 %:
-	dh $@ --parallel -Bobj
+	dh $@ -Bobj
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	cd test && ../obj/unittest
-
+endif
